/**************************************************************************
 * Copyright (c) 2016, STMicroelectronics - All Rights Reserved

 License terms: BSD 3-clause "New" or "Revised" License.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.

 3. Neither the name of the copyright holder nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef STMVL53L5CX_I2C_H
#define STMVL53L5CX_I2C_H

#define VL53L5CX_COMMS_CHUNK_SIZE  		1024

int32_t stmvl53l5cx_write_byte(
	struct i2c_client *client,
	uint8_t *i2c_buffer,
	uint16_t address,
	uint8_t value);

int32_t stmvl53l5cx_read_byte(
	struct i2c_client *client,
	uint8_t *i2c_buffer,
	uint16_t address,
	uint8_t *p_value);

int32_t stmvl53l5cx_read_multi(
	struct i2c_client *client,
	uint8_t *i2c_buffer,
	uint16_t reg_index,
	uint8_t *pdata,
	uint32_t count);

int32_t stmvl53l5cx_write_multi(
	struct i2c_client *client,
	uint8_t *i2c_buffer,
	uint16_t reg_index,
	uint8_t *pdata,
	uint32_t count);

#endif
